/***************************************************************************//**
 * @file zigbee_common_callback_dispatcher.h
 * @brief ZigBee common dispatcher declarations.
 *******************************************************************************
 * # License
 * <b>Copyright 2020 Silicon Laboratories Inc. www.silabs.com</b>
 *******************************************************************************
 *
 * The licensor of this software is Silicon Laboratories Inc. Your use of this
 * software is governed by the terms of Silicon Labs Master Software License
 * Agreement (MSLA) available at
 * www.silabs.com/about-us/legal/master-software-license-agreement. This
 * software is distributed to you in Source Code format and is governed by the
 * sections of the MSLA applicable to Source Code.
 *
 ******************************************************************************/

#ifndef SL_ZIGBEE_COMMON_CALLBACK_DISPATCHER_H
#define SL_ZIGBEE_COMMON_CALLBACK_DISPATCHER_H

#include PLATFORM_HEADER
#include "stack/include/ember.h"

{# EVENT INIT -#}
// Event Init
void sli_zigbee_af_event_init(void);
{% for cb in zigbee_af_callback -%}
{% if cb['callback_type'] == "event_init" or cb['callback_type'] == "init" -%}
void {{ cb['function_name'] }}(uint8_t init_level);
{% endif -%}
{% endfor -%}

{# LOCAL DATA INIT -#}
// Local data Init
void sli_zigbee_af_local_data_init(void);
{% for cb in zigbee_af_callback -%}
{% if cb['callback_type'] == "local_data_init" -%}
void {{ cb['function_name'] }}(uint8_t init_level);
{% endif -%}
{% endfor -%}

{# INIT DONE -#}
// Init done
void sli_zigbee_af_initDone(void);
{% for cb in zigbee_af_callback -%}
{% if cb['callback_type'] == "init_done" -%}
void {{ cb['function_name'] }}(uint8_t init_level);
{% endif -%}
{% endfor -%}

{# TICK #}
// Tick
void sli_zigbee_af_tick(void);
{% for cb in zigbee_af_callback -%}
{% if cb['callback_type'] == "tick" -%}
void {{ cb['function_name'] }}(void);
{% endif -%}
{% endfor %}
#endif // SL_ZIGBEE_COMMON_CALLBACK_DISPATCHER_H